#!/bin/bash
# Usage:
# ./run.sh [<adadep options>]

if [ -d res ]; then
    rm -f res/*
else
    mkdir res
fi

ADADEP="../src/adadep -d"
${ADADEP} -h 2>&1 | head -n 1
${ADADEP} -h >res/test_help.txt 2>&1 
${ADADEP} -wo res/test1.txt    test1+pack -- $*
${ADADEP} -wo res/test2.txt -m test1+pack -- $*

pushd ref 1>/dev/null
list=`ls *.txt`
popd 1>/dev/null
nb_passed=0
nb_failed=0
for test_case in $list; do
    diff=`diff --strip-trailing-cr res/${test_case} ref/${test_case} 2>&1 `
    if [ "$diff" == "" ]; then
	nb_passed=$((nb_passed+1))
	printf "=> %-60s%-13s <=\n" ${test_case} "       PASSED"
    else
	nb_failed=$((nb_failed+1))
	printf "=> %-60s%-13s <=\n" ${test_case} "FAILED       "
    fi;
done

echo "** Passed= $nb_passed, Failed= $nb_failed"

rm -f *.ali *.adt

if [ ${nb_failed} -ne 0 ] ; then
    .  ./failed.sh
fi
